## skesa 2.3.0

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

#setenv BOOST_PATH /netopt/ncbi_tools64/boost-1.62.0-ncbi1

ifdef BOOST_PATH
BOOST_INCL := -I $(BOOST_PATH)/include
BOOST_LIB := -L $(BOOST_PATH)/lib
endif

NGS_DIR := $(CURDIR)/NGS
VDB_PATH := $(NGS_DIR)/vdb_out
NGS_PATH := $(NGS_DIR)/ngs_out
BUILD_PATH := $(NGS_DIR)/build

VDB_INCL := -I $(VDB_PATH)/include
VDB_LIB := -L $(VDB_PATH)/lib64
NGS_INCL := -I $(NGS_PATH)/include
NGS_LIB := -L $(NGS_PATH)/lib64

CC = c++ -std=c++11
CFLAGS = -Wall -Wno-format-y2k  -pthread -fPIC -O3 -finline-functions -fstrict-aliasing \
         -fomit-frame-pointer -msse4.2 $(BOOST_INCL) $(NGS_INCL) $(VDB_INCL)
         
LIBS = $(VDB_LIB) -lncbi-ngs-c++-static -lncbi-vdb-static \
       $(NGS_LIB) -lngs-c++-static \
       -Wl,-Bstatic $(BOOST_LIB) \
       -lboost_program_options \
       -lboost_iostreams \
       -lboost_regex \
       -lboost_timer \
       -lboost_chrono \
       -lboost_system \
       -Wl,-Bdynamic -lrt -ldl -lm  -lpthread -lz

%.o: %.cpp
	$(CC) -c -o $@ $< $(CFLAGS)

all: skesa 

glb_align.o: glb_align.hpp Makefile

skesa.o: common_util.hpp concurrenthash.hpp readsgetter.hpp ngs_includes.hpp counter.hpp graphdigger.hpp assembler.hpp KmerInit.hpp DBGraph.hpp Integer.hpp LargeInt.hpp LargeInt1.hpp LargeInt2.hpp Model.hpp config.hpp Makefile $(NGS_DIR)/ngs.done
skesa: skesa.o glb_align.o
	$(CC) -o $@ $^ $(LIBS)

$(NGS_DIR)/ngs.done:
	rm -fr $(NGS_DIR)
	mkdir -p $(NGS_DIR)/ngs
	mkdir $(BUILD_PATH)
	mkdir $(NGS_PATH)
	mkdir $(VDB_PATH)
	cd $(NGS_DIR)/ngs; git init; git remote add -f origin https://github.com/ncbi/ngs.git; git config core.sparseCheckout true; echo "ngs-sdk" >> .git/info/sparse-checkout; git pull origin master
	cd $(NGS_DIR)/ngs/ngs-sdk; ./configure --prefix=$(NGS_PATH) --build-prefix=$(BUILD_PATH); make; make install
	cd $(NGS_DIR); git clone https://github.com/ncbi/ncbi-vdb.git
	cd $(NGS_DIR)/ncbi-vdb; ./configure --prefix=$(VDB_PATH) --build-prefix=$(BUILD_PATH); make; make install
	touch $@

=== debian/changelog ===
skesa (2.3.0-2) unstable; urgency=medium

  * debhelper-compat 12

 -- Andreas Tille <tille@debian.org>  Mon, 19 Aug 2019 14:27:03 +0200

skesa (2.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #932294)

 -- Andreas Tille <tille@debian.org>  Wed, 17 Jul 2019 13:55:35 +0200

=== debian/control ===
Source: skesa
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libboost-dev,
               libboost-chrono-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-timer-dev,
               libncbi-vdb-dev,
               libngs-sdk-dev
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/med-team/skesa
Vcs-Git: https://salsa.debian.org/med-team/skesa.git
Homepage: https://github.com/ncbi/SKESA

Package: skesa
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: strategic Kmer extension for scrupulous assemblies
 SKESA is a DeBruijn graph-based de-novo assembler designed for
 assembling reads of microbial genomes sequenced using Illumina.
 Comparison with SPAdes and MegaHit shows that SKESA produces assemblies
 that have high sequence quality and contiguity, handles low-level
 contamination in reads, is fast, and produces an identical assembly for
 the same input when assembled multiple times with the same or different
 compute resources. SKESA has been used for assembling over 272,000 read
 sets in the Sequence Read Archive at NCBI and for real-time pathogen
 detection.

=== debian/watch ===
version=4

https://github.com/ncbi/SKESA/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@

## skesa 2.4.0

=== Makefile ===
--- 
+++ 
@@ -39,10 +39,10 @@
 NGS_INCL := -I $(NGS_PATH)/include
 NGS_LIB := -L $(NGS_PATH)/lib64
 
-CC = c++ -std=c++11
+CC = c++ -std=c++11 -fdiagnostics-color=never
 CFLAGS = -Wall -Wno-format-y2k  -pthread -fPIC -O3 -finline-functions -fstrict-aliasing \
          -fomit-frame-pointer -msse4.2 $(BOOST_INCL) $(NGS_INCL) $(VDB_INCL)
-         
+
 LIBS = $(VDB_LIB) -lncbi-ngs-c++-static -lncbi-vdb-static \
        $(NGS_LIB) -lngs-c++-static \
        -Wl,-Bstatic $(BOOST_LIB) \
@@ -57,13 +57,29 @@
 %.o: %.cpp
 	$(CC) -c -o $@ $< $(CFLAGS)
 
-all: skesa 
+binaries=skesa gfa_connector kmercounter
+
+all: $(binaries)
+
+.PHONY: clean
+
+clean: 
+	rm -f $(binaries) *.o $(NGS_DIR)/ngs.done
 
 glb_align.o: glb_align.hpp Makefile
 
-skesa.o: common_util.hpp concurrenthash.hpp readsgetter.hpp ngs_includes.hpp counter.hpp graphdigger.hpp assembler.hpp KmerInit.hpp DBGraph.hpp Integer.hpp LargeInt.hpp LargeInt1.hpp LargeInt2.hpp Model.hpp config.hpp Makefile $(NGS_DIR)/ngs.done
+skesa.o: common_util.hpp concurrenthash.hpp readsgetter.hpp ngs_includes.hpp counter.hpp graphdigger.hpp assembler.hpp KmerInit.hpp DBGraph.hpp Integer.hpp LargeInt.hpp LargeInt1.hpp LargeInt2.hpp Model.hpp config.hpp glb_align.hpp Makefile $(NGS_DIR)/ngs.done
 skesa: skesa.o glb_align.o
 	$(CC) -o $@ $^ $(LIBS)
+
+gfa_connector.o: gfa.hpp glb_align.hpp common_util.hpp concurrenthash.hpp readsgetter.hpp ngs_includes.hpp graphdigger.hpp KmerInit.hpp  DBGraph.hpp Integer.hpp LargeInt.hpp LargeInt1.hpp LargeInt2.hpp Model.hpp config.hpp Makefile $(NGS_DIR)/ngs.done
+gfa_connector: gfa_connector.o glb_align.o
+	$(CC) -o $@ $^ $(LIBS)
+
+kmercounter.o: common_util.hpp concurrenthash.hpp readsgetter.hpp ngs_includes.hpp counter.hpp graphdigger.hpp assembler.hpp KmerInit.hpp DBGraph.hpp Integer.hpp LargeInt.hpp LargeInt1.hpp LargeInt2.hpp Model.hpp config.hpp glb_align.hpp Makefile $(NGS_DIR)/ngs.done
+kmercounter: kmercounter.o glb_align.o
+	$(CC) -o $@ $^ $(LIBS)
+
 
 $(NGS_DIR)/ngs.done:
 	rm -fr $(NGS_DIR)

=== debian/changelog ===
skesa (2.4.0-7) unstable; urgency=medium

  [ Andreas Tille ]
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

  [ Helmut Grohne ]
  * Do not use variable CC for the C++ compiler
    Closes: #1112688

 -- Andreas Tille <tille@debian.org>  Sat, 20 Dec 2025 23:12:25 +0100

skesa (2.4.0-6) unstable; urgency=medium

  * debian/patches/hardening.patch: Reinstate use of dpkg-supplied CFLAGS.
    The addition accidentally got lost in the course of updating
    use_debian_packaged_ngs-sdk.patch.
  * debian/patches/no_sse4.2.patch (new): Don't use SSE 4.2.  It's a
    baseline violation on x86, and entirely unavailable elsewhere.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 22 Jan 2023 13:35:16 -0500

skesa (2.4.0-5) unstable; urgency=medium

  [ Andreas Tille ]
  * Cleanup d/rules

  [ Aaron M. Ucko ]
  * Build against ncbi-vdb 3.x and sra-sdk 3.x (which subsumed ngs-sdk).
  * link_boost_dynamically.patch (new): Drop upstream linkage override.
  * Add myself to Uploaders.
  * Standards-Version: 4.6.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 20 Jan 2023 18:03:43 -0500

skesa (2.4.0-4) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 25 Nov 2022 22:13:39 +0100

skesa (2.4.0-3) unstable; urgency=medium

  * Versioned Build-Depends: libncbi-vdb-dev (>= 2.11.2+dfsg-2)
    Closes: #997294

 -- Andreas Tille <tille@debian.org>  Mon, 01 Nov 2021 17:12:21 +0100

skesa (2.4.0-2) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 29 Sep 2021 21:49:56 +0200

skesa (2.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Created https://github.com/ncbi/SKESA/pull/28 to hopefully avoid
    the hardening patch.

 -- Steffen Moeller <moeller@debian.org>  Sun, 17 May 2020 20:14:52 +0200

=== debian/control ===
Source: skesa
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
 Aaron M. Ucko <ucko@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 libboost-dev,
 libboost-chrono-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libboost-timer-dev,
 libncbi-vdb-dev,
 libngs-c++-dev,
Vcs-Browser: https://salsa.debian.org/med-team/skesa
Vcs-Git: https://salsa.debian.org/med-team/skesa.git
Homepage: https://github.com/ncbi/SKESA
Rules-Requires-Root: no

Package: skesa
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: strategic Kmer extension for scrupulous assemblies
 SKESA is a DeBruijn graph-based de-novo assembler designed for
 assembling reads of microbial genomes sequenced using Illumina.
 Comparison with SPAdes and MegaHit shows that SKESA produces assemblies
 that have high sequence quality and contiguity, handles low-level
 contamination in reads, is fast, and produces an identical assembly for
 the same input when assembled multiple times with the same or different
 compute resources. SKESA has been used for assembling over 272,000 read
 sets in the Sequence Read Archive at NCBI and for real-time pathogen
 detection.

=== debian/watch ===
Version: 5

Template: Github
Owner: ncbi
Project: SKESA
